-- script by Defender

print("mod loaded: pricereport");

pricereport = {};


function pricereport:loadMap(name)

  self.stations = {};
  self.numstations = 0;
  self.numfruits = 0;
  self.visible = {};
  self.showprices = false;
  self.dificutly = 6000;  
  local cnt = true;
  if g_currentMission.missionStats.difficulty==2 then
    self.dificutly=3000;
  end;
  if g_currentMission.missionStats.difficulty==3 then
    self.dificutly=1000;
  end;
  for i=1, table.maxn(g_currentMission.tipTriggers) do
    if g_currentMission.tipTriggers[i].appearsOnPDA then
      local s=g_currentMission.tipTriggers[i].stationName;
      self.numstations=self.numstations+1;
      table.insert(self.stations,i,{});
      for a=1, FruitUtil.NUM_FRUITTYPES do
        self.visible[a]=self.visible[a] or false;
        local l=g_currentMission.tipTriggers[i].acceptedFruitTypes[a];
        if l~=nil then
          v=g_currentMission.tipTriggers[i].priceMultipliers[a];
          self.visible[a]=true;
        else
          v=nil;
        end;        
        self.stations[i][a]=v;
        if cnt then
          self.numfruits=self.numfruits+1;
        end;
      end;
    end;       
  end;
  local tmp=self.numfruits;
  for a=1, self.numfruits do
    if not self.visible[a] then
      tmp=tmp-1;
    end;
  end;
  self.numfruits=tmp;
  self.HudInfoWidth=0.6/(self.numstations+2);  
  self.subHudBack = Utils.getFilename("$dataS/missions/hud_env_base.png", pricereport.baseDirectory);
  self.subHudInfoPoxX = 0.2; --  links rechts
  self.subHudInfoPoxY = 0.8; --   hoch runter
  self.subHudBackPoxX = 0.2; -- links rechts
  self.subHudBackWidth = 0.6; -- breite
  self.subHudBackPoxY = 0.5-((0.105+(self.numfruits*0.026))/2);--0.1; --  ; hoch runter ( weniger runter ) FruitUtil.NUM_FRUITTYPES 
  self.subHudBackHeight = ((0.105+(self.numfruits*0.026))); --0.8; -- hoehe
  self.subHudInfoPoxY = 0.5+((0.105+(self.numfruits*0.026))/2)-0.055; 
  pricereport.Pozadi = Overlay:new("Pozadi", pricereport.subHudBack, pricereport.subHudBackPoxX, pricereport.subHudBackPoxY, pricereport.subHudBackWidth, pricereport.subHudBackHeight);

  self.loadedMap = name;
end;
function pricereport:deleteMap()
end;
function pricereport:update(dt)
	if InputBinding.hasEvent(InputBinding.TOGGLE_PDA) then 
		if not self.showprices then
      if g_currentMission.missionStats.showPDA and g_currentMission.missionStats.screen==3 then     
        self.showprices = true;
        g_currentMission.missionStats.showPDA = false;
      end;
    else
      self.showprices = false;
      g_currentMission.missionStats.showPDA = true;
      g_currentMission.missionStats.screen=4;
    end;  
	end; 

end;

function pricereport:keyEvent(unicode, sym, modifier, isDown) 
end;
   
function pricereport:draw()
local prvnisloupec=true;
  if self.showprices then
    self.Pozadi:render();
    setTextBold(true);
		setTextColor(1,1,1,1);
		renderText(self.subHudInfoPoxX+0.023, self.subHudInfoPoxY , 0.05, "Informace o vykupnich cenach");
		local x = 0;
    renderText(self.subHudInfoPoxX+0.023+(x*self.HudInfoWidth), self.subHudInfoPoxY-0.035 , 0.03, g_i18n:getText("PricePerTon"));		
    for i=1, table.maxn(self.stations) do
      local a = self.stations[i];
      if a~=nil then        
        x=x+1;
        setTextBold(true);
        setTextColor(1,1,1,1);
        local StName = g_i18n:getText(g_currentMission.tipTriggers[i].stationName);
        if string.find(StName,".xml")~=nil then
          StName = g_currentMission.tipTriggers[i].stationName;
        end;
        renderText(self.subHudInfoPoxX+((x+1)*self.HudInfoWidth), self.subHudInfoPoxY-0.035 , 0.03, StName);
        setTextBold(false);
        local scr_y = 1;
        for y=1, table.maxn(a) do
          if (FruitUtil.fruitIndexToDesc[y].pricePerLiter==FruitUtil.fruitIndexToDesc[y].yesterdaysPrice) then 
            setTextColor(1,1,1,1);
          end;
          if (FruitUtil.fruitIndexToDesc[y].pricePerLiter<FruitUtil.fruitIndexToDesc[y].yesterdaysPrice) then 
            setTextColor(1,0,0,1);
          end;
          if (FruitUtil.fruitIndexToDesc[y].pricePerLiter>FruitUtil.fruitIndexToDesc[y].yesterdaysPrice) then 
            setTextColor(0,1,0,1);
          end;
          if prvnisloupec then
            local s=g_i18n:getText(FruitUtil.fruitIndexToDesc[y].name);
            if string.find(s,".xml")~=nil then              
              s=FruitUtil.fruitIndexToDesc[y].name;
              if s=="dryGrass" then 
                s="Seno";
              end;
              if s=="silage" then 
                s="Silaz";
              end;
              if s=="manure" then 
                s="Mocuvka";
              end;
              if s=="dung" then 
                s="Hnuj";
              end;                                       
            end;
            if self.visible[y] then
              renderText(self.subHudInfoPoxX+(0*self.HudInfoWidth)+0.023, self.subHudInfoPoxY-0.035-(scr_y*0.026) , 0.025, s);
            end;
          end; 
          local b=a[y];
          if (b~=nil) then             
            local c=(tonumber(b)*self.dificutly*tonumber(FruitUtil.fruitIndexToDesc[y].pricePerLiter)*g_i18n.currencyFactor);
            local p=tostring(c);
            if self.visible[y] then
              renderText(self.subHudInfoPoxX+((x+1)*self.HudInfoWidth), self.subHudInfoPoxY-0.035-(scr_y*0.026) , 0.025, p);
            end;
          end;
          if self.visible[y] then
            scr_y=scr_y+1;
          end;
        end;
        prvnisloupec=false;
      end;  
    end;      
  end;
end;

function pricereport:delete()
	if self.Pozadi ~= nil then
		self.Pozadi:delete();
	end; 
end;

addModEventListener(pricereport);

